VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "cMCI"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False

Option Explicit

' --------------------------------------------------------------------------
' \\ Para reproducir el mp3
' --------------------------------------------------------------------------

Enum eCommands
    [ePlayMp3] = 0
    [ePauseMp3] = 1
    [eStopMp3] = 2
    [eCloseMp3] = 3
End Enum

Private Declare Function GetShortPathName Lib "kernel32" Alias "GetShortPathNameA" (ByVal lpszLongPath As String, ByVal lpszShortPath As String, ByVal lBuffer As Long) As Long
Private Declare Function mciExecute Lib "winmm.dll" (ByVal lpstrCommand As String) As Long

Private mCurrentFileName                    As String

Property Get CurrentFileName() As String
    CurrentFileName = mCurrentFileName
End Property

Function ExecuteCommand(Command As eCommands, ByVal sPath As String) As Boolean
    
    Dim bRet As Boolean
    Dim sCommand As String
    
    If Command = eCloseMp3 Then
        bRet = mciExecute("Close All")
        Exit Function
    End If
    
    If Command = eStopMp3 Then sCommand = "Stop "
    If Command = ePauseMp3 Then sCommand = "Pause "
    If Command = ePlayMp3 Then sCommand = "Play "
    
    sPath = GetShortFileName(sPath)
    
    If sPath = "" Then Exit Function
    
    If Command = eStopMp3 Then
       If mCurrentFileName <> "" Then
           bRet = mciExecute(sCommand & mCurrentFileName)
       End If
    ElseIf Command = ePauseMp3 Then
       If mCurrentFileName <> "" Then
           bRet = mciExecute(sCommand & mCurrentFileName)
       End If
    ElseIf Command = ePlayMp3 Then
        If sPath <> mCurrentFileName Then
            mciExecute ("Close All")
        End If
        'If mCurrentFileName <> "" Then
        bRet = mciExecute(sCommand & sPath)
        'End If
    End If
    
    If bRet And Command = ePlayMp3 Then mCurrentFileName = sPath
    
    ExecuteCommand = bRet
    
End Function

Function GetShortFileName(ByRef sPath As String) As String
    Dim sBuffer As String * 256
    Dim lRet As Long
    lRet = GetShortPathName(sPath, sBuffer, Len(sBuffer))
    If lRet Then
       GetShortFileName = Left(sBuffer, lRet)
    End If
End Function

Private Sub Class_Initialize()
    Call ExecuteCommand(eCloseMp3, "")
End Sub

Private Sub Class_Terminate()
    Call ExecuteCommand(eCloseMp3, "")
End Sub
