VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "cStyles"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

' --------------------------------------------------------------------------
' \\ Para establecer los estilos
' --------------------------------------------------------------------------

Const SWP_NOMOVE = &H2
Const SWP_NOSIZE = &H1
Private Const GWL_EXSTYLE = (-20)
Private Const WS_EX_CLIENTEDGE = &H200
Private Const WS_EX_STATICEDGE = &H20000
Private Const SWP_FRAMECHANGED = &H20
Private Const SWP_NOACTIVATE = &H10
Private Const SWP_NOZORDER = &H4
Private Const SWP_DRAWFRAME = SWP_FRAMECHANGED
Private Const SWP_FLAGS = SWP_NOZORDER Or _
                          SWP_NOSIZE Or _
                          SWP_NOMOVE Or _
                          SWP_DRAWFRAME

Enum eStyleGui
    [eStyle1] = 0
    [eStyle2] = 1
    [eStyle3] = 2
    [eStyle4] = 3
    [eStyle5] = 4
    [eStyle6] = 5
End Enum

Private Declare Function GetWindowLong Lib "user32" Alias "GetWindowLongA" (ByVal hwnd As Long, ByVal nIndex As Long) As Long
Private Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongA" (ByVal hwnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long
Private Declare Function SetWindowPos Lib "user32" (ByVal hwnd As Long, ByVal hWndInsertAfter As Long, ByVal x As Long, ByVal y As Long, ByVal cx As Long, ByVal cy As Long, ByVal wFlags As Long) As Long

Public SkinBtn                    As Integer
Public BackColorTextBox           As Long
Public BackColorContainers        As Long
Public BackColorControls          As Long
Public ForeColorTitles            As Long
Public ForeColorLabels            As Long
Public ForeColorControls          As Long
Public ForeColorSelectedItems     As Long
Public ForeColorLines             As Long
Public ForeCololorButtons         As Long
Public ForeCololorUpButtons       As Long
Public UseBoldColumnHeader        As Boolean
Public BackColorControlFocus      As Long
Public CurrentStyle               As eStyleGui
Private mSkinLVPath               As String
Private mPathSkinToolBar          As String

Sub ChangeStyle(OwnerForm As Form, pColSClassLv As Collection, pBtnSkin As ucBtnSkin, pCSCToolBar As cSubclassToolBar, lStyle As eStyleGui)
    
    
   CurrentStyle = lStyle
   Select Case lStyle
        Case 0
            BackColorContainers = RGB(86, 96, 120)
            BackColorControls = vbBlack 'RGB(57, 68, 114)
            BackColorTextBox = BackColorControls
            ForeColorTitles = vbWhite
            ForeColorLabels = vbWhite
            ForeColorControls = vbWhite
            ForeColorLines = RGB(122, 130, 149)
            ForeCololorButtons = vbWhite
            ForeCololorUpButtons = vbYellow
            mSkinLVPath = App.Path & "\skins\skin2.bmp"
            UseBoldColumnHeader = True
            ForeColorSelectedItems = vbGreen
            BackColorControlFocus = BackColorContainers
            SkinBtn = 6
            'mSkinMenu = 6
            mPathSkinToolBar = App.Path & "\skins\Skin_WindowsMedia.bmp"
            Call pCSCToolBar.SetSkinPicture(LoadPicture(mPathSkinToolBar))
            
        Case 1
            BackColorContainers = RGB(220, 235, 254)
            BackColorControls = RGB(240, 247, 255)
            BackColorTextBox = BackColorControls
            BackColorControlFocus = BackColorContainers
            ForeColorTitles = RGB(41, 90, 171)
            ForeColorSelectedItems = ForeColorTitles
            ForeColorLabels = RGB(41, 90, 171)
            ForeColorControls = vbBlack
            ForeColorLines = RGB(191, 209, 233)
            ForeCololorButtons = ForeColorTitles
            ForeCololorUpButtons = ForeColorTitles
            mSkinLVPath = App.Path & "\skins\skin28.bmp"
            mPathSkinToolBar = App.Path & "\skins\Skinx.bmp"
            UseBoldColumnHeader = False
            SkinBtn = 15
            Call pCSCToolBar.SetSkinPicture(LoadPicture(mPathSkinToolBar))
            Call pCSCToolBar.SetTextColors(RGB(41, 90, 171), RGB(41, 90, 171), RGB(190, 190, 190))
        Case 2
            BackColorContainers = RGB(245, 245, 245)
            BackColorControls = vbWhite
            BackColorTextBox = BackColorControls
            BackColorControlFocus = BackColorContainers
            ForeColorTitles = RGB(181, 181, 181)
            ForeColorLabels = RGB(181, 181, 181)
            ForeColorSelectedItems = vbBlack
            ForeColorControls = vbBlack
            ForeColorLines = RGB(230, 230, 230)
            ForeCololorButtons = vbBlack
            ForeCololorUpButtons = vbBlack
            UseBoldColumnHeader = False
            mSkinLVPath = App.Path & "\skins\skin27.bmp"
            mPathSkinToolBar = App.Path & "\skins\Skin_Hotmail.bmp"
            SkinBtn = 12
            Call pCSCToolBar.SetSkinPicture(LoadPicture(mPathSkinToolBar))
        Case 3
            BackColorContainers = RGB(251, 251, 251)
            BackColorControls = vbWhite
            BackColorTextBox = BackColorControls
            BackColorControlFocus = BackColorContainers
            ForeColorTitles = RGB(61, 130, 6)
            ForeColorLabels = RGB(121, 129, 141)
            ForeColorSelectedItems = ForeColorTitles
            ForeColorControls = vbBlack
            ForeColorLines = RGB(178, 182, 197)
            ForeCololorButtons = vbBlack
            ForeCololorUpButtons = vbBlack
            UseBoldColumnHeader = False
            mSkinLVPath = App.Path & "\skins\skin30.bmp"
            SkinBtn = 21
            Call pCSCToolBar.SetSkinPicture(LoadPicture(App.Path & "\skins\Skin_WMP_Verde.bmp"))
        Case 4
            BackColorContainers = vbWhite
            BackColorControls = vbWhite
            BackColorTextBox = BackColorControls
            BackColorControlFocus = pBtnSkin.GetSkinsColors(Hot_Skin)
            ForeColorTitles = RGB(38, 143, 190)
            ForeColorSelectedItems = ForeColorTitles
            ForeColorLabels = vbBlack
            ForeColorControls = vbBlack
            ForeColorLines = RGB(240, 240, 240)
            ForeCololorButtons = vbBlack
            ForeCololorUpButtons = vbBlack
            UseBoldColumnHeader = False
            mSkinLVPath = App.Path & "\skins\skin27.bmp"
            mPathSkinToolBar = App.Path & "\skins\Skin_Hotmail.bmp"
            SkinBtn = 11
            Call pCSCToolBar.SetSkinPicture(LoadPicture(mPathSkinToolBar))
   End Select
   
   Dim xCsLv As cSubclassListView
   For Each xCsLv In pColSClassLv
        Call setColumnHeader(xCsLv, LoadPicture(mSkinLVPath), ForeCololorButtons, ForeCololorUpButtons, False, UseBoldColumnHeader)
        
   Next
   
   Dim xCtrl As Control
   For Each xCtrl In OwnerForm.Controls
       With xCtrl
            If TypeOf xCtrl Is Toolbar Then
               
               Call pCSCToolBar.SubClassToolBar(xCtrl.hwnd)
               
            ElseIf TypeOf xCtrl Is ListView Then
                .BorderStyle = 0
                .Appearance = 0
                .BackColor = BackColorControls
                .ForeColor = ForeColorControls
                .FullRowSelect = True
            ElseIf TypeOf xCtrl Is Frame Then
                .BackColor = BackColorContainers
                setFlatBorder xCtrl.hwnd
                '.BorderStyle = 0
            ElseIf (TypeOf xCtrl Is ListBox) Or (TypeOf xCtrl Is ComboBox) Then
                .BackColor = BackColorControls
                .ForeColor = ForeColorControls
                Call setFlatBorder(xCtrl.hwnd)
            ElseIf (TypeOf xCtrl Is ucBtnSkin) Then
                
                .Skin = SkinBtn
            ElseIf TypeOf xCtrl Is Line Then
                .BorderColor = ForeColorLines
            ElseIf TypeOf xCtrl Is Shape Then
                .BorderColor = ForeColorLines
                .BackColor = BackColorControls
            ElseIf TypeOf xCtrl Is Label Then
                .BackStyle = 0
                .AutoSize = True
                Select Case LCase(xCtrl.Name)
                    Case Is = LCase("lblTitles")
                       .ForeColor = ForeColorTitles
                       .FontName = "Verdana"
                       .Font.Bold = True
                    Case Is = LCase("lblDesc")
                       .ForeColor = ForeColorLabels
                       .Font.Bold = True
                    Case Else
                       .ForeColor = ForeColorLabels
                       .Font.Bold = False
                End Select
                
                If .Tag = "h1" Then .Font.Size = 18
                If .Tag = "h2" Then .Font.Size = 16
                If .Tag = "h3" Then .Font.Size = 12
                If .Tag = "" Then .Font.Size = 8
                
                
            ElseIf TypeOf xCtrl Is PictureBox Then
                .BackColor = BackColorContainers
                .BorderStyle = 0
                .ForeColor = ForeCololorButtons
                .Font.Bold = True
                .Font.Size = 10
            ElseIf TypeOf xCtrl Is textBox Then
                .BackColor = BackColorTextBox
                .ForeColor = ForeColorControls
                If xCtrl.BorderStyle = 1 Then
                    Call setFlatBorder(xCtrl.hwnd)
                End If
            End If
       End With
   Next
   OwnerForm.BackColor = BackColorContainers
   OwnerForm.BackColor = RGB(241, 243, 248)
End Sub

Private Sub setColumnHeader( _
    clsSubLv As cSubclassListView, _
    stdSkin As StdPicture, _
    lColorNormal As Long, _
    lColorUp As Long, _
    Optional bIconAlingmentRight As Boolean = False, _
    Optional bTextBold As Boolean = False)
    
    With clsSubLv
        .SkinPicture = stdSkin
        .TextNormalColor = lColorNormal
        .TextResalteColor = lColorUp
        .IconAlingmentRight = bIconAlingmentRight
        .HedersFontBlod = bTextBold
    End With
End Sub

Sub setFlatBorder(ByVal hwnd As Long)
    Dim lStyle As Long
        lStyle = GetWindowLong(hwnd, GWL_EXSTYLE)
        lStyle = lStyle And Not WS_EX_CLIENTEDGE Or WS_EX_STATICEDGE
        If SetWindowLong(hwnd, GWL_EXSTYLE, lStyle) Then
            Call SetWindowPos(hwnd, 0, 0, 0, 0, 0, SWP_NOACTIVATE Or SWP_NOZORDER Or SWP_FRAMECHANGED Or SWP_NOSIZE Or SWP_NOMOVE)
        End If
End Sub

